package com.maroontress.coverture.gcda;

import java.io.IOException;
import java.nio.ByteBuffer;

/**
   ޥ쥳ɤǤ

   summary: int32:checksum count-summary
   count-summary: int32:num int32:runs int64:sum int64:max int64:sum_max
*/
public final class SummaryRecord {

    /** åǤ */
    private int checksum;

    /** 󥿿Ǥ */
    private int num;

    /** ¹ԲǤ */
    private int runs;

    /** ٤ƤΥ󥿤ιפǤ */
    private long sumAll;

    /** maximum value on a single run. */
    private long runMax;

    /** sum of individual run max values. */
    private long sumMax;

    /**
       ХȥХåե饵ޥ쥳ɤϤơ󥹥󥹤
       ޤХȥХåեΰ֤ϥޥ쥳ɤΥϤľ
       ܤǤʤФʤޤϡХȥХåեΰ֤
       ޥ쥳ɤμΰ֤˿ʤߤޤ

       @param bb ХȥХåե
       @throws IOException ϥ顼
    */
    public SummaryRecord(final ByteBuffer bb) throws IOException {
	int length = bb.getInt();
	int next = bb.position() + 4 * length;

	checksum = bb.getInt();
	num = bb.getInt();
	runs = bb.getInt();
	sumAll = bb.getLong();
	runMax = bb.getLong();
	sumMax = bb.getLong();

	bb.position(next);
    }

    /**
       ¹Բޤ

       @return ¹Բ
    */
    public int getRuns() {
	return runs;
    }
}
