package com.maroontress.coverture.gcno;

import com.maroontress.coverture.CorruptedFileException;
import com.maroontress.coverture.Tag;
import com.maroontress.coverture.UnexpectedTagException;
import java.io.IOException;
import java.nio.ByteBuffer;

/**
   ܥ֥å쥳ɤǤ

   basic_block: header int32:flags*
*/
public final class BasicBlockRecord {

    /** ե饰Ǥ */
    private int[] flags;

    /**
       ХȥХåեBASIC_BLOCK쥳ɤϤBASIC_BLOCK쥳
       ɤޤХȥХåեΰ֤BASIC_BLOCK쥳ɤƬ
       ΰ֤ǤʤФʤޤϡХȥХåեΰ
       ֤BASIC_BLOCK쥳ɤμΰ֤˰ưޤ

       @param bb ХȥХåե
       @throws IOException ϥ顼
       @throws UnexpectedTagException ͽʤ򸡽
    */
    public BasicBlockRecord(final ByteBuffer bb)
	throws IOException, UnexpectedTagException {
	int tag = bb.getInt();
	int length = bb.getInt();
	int next = bb.position() + 4 * length;

	if (tag != Tag.BLOCK) {
	    String m = String.format("unexpected tag: 0x%x", tag);
	    throw new UnexpectedTagException(m);
	}
	flags = new int[length];
	for (int k = 0; k < length; ++k) {
	    flags[k] = bb.getInt();
	}
	bb.position(next);
    }

    /**
       ե饰ޤ

       @return ե饰
    */
    public int[] getFlags() {
	return flags;
    }
}
